HIRED3 	ORG	6000H
 ENTRY	LD	HL,3C00H	; FOR SCREEN DISPLAY
 	DI
 ;
 WAIT	NOP
 ;
 LOOPER	LD	E,80H		; GET MASK VALUE READY
 	CALL	DELAY5		; DELAY PAST BIT TWEAK
 WAITX	CALL	OUTSIG		; RESET INPUT FLIP-FLOP
 	IN	A,(0FFH)	; GET INPUT VALUE
 	RLA	   		; SEE IF F-F TRIGGERED
 	JR	NC,WAITX	; WAIT IF STILL ZERO
 	LD	D,0		; PREPARE DESTINATION
 ;
 WAIT2	CALL	OUTSIG		; RESET INPUT FLIP-FLOP
 	IN	A,(0FFH)	; GET INPUT VALUE
 	INC	D		; FIRST TRIP THROUGH LOOP
 	RLA			; CHECK STATUS OF INPUT
 	JR	C,WAIT2		; WAIT IF STILL ONE
 	LD	A,D		; PREPARE COUNTER IN D
 	CP	08H		; DID IT WAIT SYNC LOOP?
 	JR	C,WAIT		; TRY AGAIN IF TOO SMALL
 	LD	B,8		; NUMBER OF BITS TO READ
 	LD	D,0		; PREPARE D WITH ALL 0'S
 	LD	C,0		; PREPARE FOR BYTE START
 ;
 LOOP	CALL	DELAY5		; ONE BIT DELAY VALUE
 	CALL	OUTSIG		; RESET INPUT FLIP-FLOP
 	IN	A,(0FFH)	; CHECK VALUE AT INPUT
 	AND	E		; MASK OUT OTHER BITS
 	CP	C		; TEST A-C TO SET CARRY
 	JP	Z,NEXT1		; IF COMPARISON IS SAME
 	SET	7,D		; SET THE BIT IF A<>C
 	JP	NEXT2		; EQUALIZE TIMING
 NEXT1	OUT	(0),A		; DO NOTHING REAL HERE...
 	AND	0FFH		; ... AND NOTHING AGAIN
 NEXT2	RRC	D		; BUMP D ALONG
 	AND	E		; MASK OTHER BITS IN A
 	JP	Z,JUMPX1	; JUMP IF BIT IS HIGH
 WAIT3	CALL	OUTSIG		; RESET FLIP-FLOP
 	IN	A,(0FFH)	; GET VALUE FROM INPUT
 	AND	E		; CHECK FOR CHANGE
 	JP	NZ,WAIT3	; LOOP TILL BIT GOES LOW
 	JP	OUT		; DONE WITH THIS BYTE
 JUMPX1	CALL	OUTSIG		; RESET FLIP-FLOP
 	IN	A,(0FFH)	; GET VALUE FROM INPUT
 	AND	E		; CHECK FOR CHANGE
 	JP	Z,JUMPX1	; LOOP TILL BIT GOES HIGH
 	JP	OUT		; READY - SET - GO
 OUT	LD	C,A		; SAVE VALUE FOR COMPARE
 	DJNZ	LOOP		; DO NEXT BIT OF 8
 ;
 	LD	(HL),D		; SAVE VALUE ON SCREEN
 	INC	HL		; GET NEXT MEM LOCATION
 	LD	A,H		; GET VALUE INTO A
 	CP	40H		; IS IT AT END OF SCREEN?
 	JP	NZ,LOOPER	; IF NOT JUST GO BACK
 	LD	HL,3C00H	; RESET SCREEN VALUE
 	JP	LOOPER		; KEEP DOING IT
 ;
 ;
 ;
 ;
 ;
 OUTSIG	LD	A,(403DH)	; GET OUTPUT LATCH FLAG
 	OUT	(0FFH),A	; RESET FLIP FLOP
 	RET			; BACK TO MAIN PROGRAM
 ;
 ;
 DELAY5	PUSH	AF		; SAVE VALUES
 	PUSH	BC		; SAVE VALUES
 	LD	BC,07H		; DELAY VALUE
 	CALL	0060H		; DO IT
 	POP	BC		; RESTORE VALUES
 	POP	AF		; RESTORE VALUES
 	RET
 ;
 DELAY6	PUSH	AF
 	PUSH	BC
 	LD	BC,9
 	CALL	0060H
 	POP	BC
 	POP	AF
 	RET
 ;
 ;
 ;
 	END	ENTRY
